/** @file task_message.h
 *  @brief TaskMessageNXwb_
 *
 *  @author yasufuku
 *  @date 2004/07
 *  @version 0.10
 *
 *  Copyright(C) 2004 Kensuke Yasufuku
 */

#ifndef _TASK_MESSAGE_H_
#define _TASK_MESSAGE_H_

#include "include.h"

//====================================================================
// 񋓌^
//====================================================================
//----------------------------------------------------
// ^XNbZ[W^O
//----------------------------------------------------
enum eTaskMessageTag {	
	TM_INIT = 0,	// ^XNbZ[W^O
	TM_MAIN,		// ^XNsbZ[W^O
	TM_KILL,		// ^XNbZ[W^O
	TM_UPDATE,		// XVbZ[W^O
	TM_RENDER,		// _ObZ[W^O
	TM_RESIZE,		// EBhETCY̕ύX
};

enum eTaskMessageFlag {	
	TM_TO_NODE = 0,	// m[hւ̃bZ[W
	TM_TO_TREE,		// c[ւ̃bZ[W
};

//====================================================================
// NX`
//====================================================================
class Task;
/**
 *	  @brief TaskMessageNX
 *
 *    ^XNbZ[WNX
 */
class TaskMessage
{
public:
	int		m_nTag;		///< ^O
	int		m_nFlag;	///< tO
	Task *	m_pSender;	///< M^XN
	
public:
	/// RXgN^(1)
	TaskMessage( int nTag, Task * pSender = NULL ) {
		m_nTag    = nTag;
		m_nFlag   = TM_TO_NODE;
		m_pSender = pSender;
	}

	/// RXgN^(2)
	TaskMessage( int nTag, int nFlag, Task * pSender = NULL ) {
		m_nTag    = nTag;
		m_nFlag   = nFlag;
		m_pSender = pSender;
	}										
	virtual ~TaskMessage(){;}				///< fXgN^

	int    Tag(){ return m_nTag; }			///< ^O擾
	int    Flag(){ return m_nFlag; }		///< tO擾
	Task * Sender() { return m_pSender;  }	///< M^XN擾
};


#endif //_TASK_MESSAGE_
