/** @file font.frag
 *  @brief tHgp
 *
 *  @author yasufuku
 *  @date 2011/02
 *  @version 0.10
 *
 *  Copyright(C) 2011 Kensuke Yasufuku
 */
#version 130

uniform vec4 Color = vec4(1.0f, 1.0f, 1.0f, 1.0f );
uniform sampler2D DiffuseMap;

in  vec2 TexCoord;

out vec4 oColor;

void main() {
     oColor.rgb = Color.rgb;
     oColor.a   = texture( DiffuseMap,TexCoord ).a * Color.a;
}
