/** @file sprite.vert
 *  @brief ^XvCg
 *
 *  @author yasufuku
 *  @date 2011/02
 *  @version 0.10
 *
 *  Copyright(C) 2011 Kensuke Yasufuku
 */
#version 130

uniform mat4 MVPMatrix;
uniform mat4 WorldMatrix;

in  vec4 Position;
in  vec2 UV0;
in  vec4 VColor;

out vec2 TexCoord;
out vec4 VertexColor;

void main() {

     gl_Position = MVPMatrix * Position;
     VertexColor = VColor;
     TexCoord    = UV0;
}
