/** @file point_sprite.h
 *  @brief Point SpriteNXwb_
 *
 *  @author yasufuku
 *  @date 2011/03
 *  @version 0.20
 *
 *  Copyright(C) 2004-2011 Kensuke Yasufuku
 */
#ifndef _POINT_SPRITE_H_
#define _POINT_SPRITE_H_

#include "include.h"
#include "shader_base.h"

/**
 *  @brief Point SpriteNX
 *
 *	|CgXvCgNX
 */
class PointSprite
{
private:
	u32				m_unVSize;
	u32				m_unCount;
	GLuint			m_VBO;
	ShaderBase *	m_pShader;
	
protected:
	
public:
	PointSprite();				///< RXgN^
	virtual ~PointSprite();		///< fXgN^
	int  Init( size_t size, u32 count, float * pData );
	int  Draw( float * pData );
	GLuint VBO(){ return m_VBO; }
};

#endif //_VB_MESH_H_
