/** @file tex_data.h
 *  @brief eNX`f[^\̃wb_
 *
 *  @author yasufuku
 *  @date 2011/02
 *  @version 0.20
 *
 *  Copyright(C) 2004-2011 Kensuke Yasufuku
 */

#ifndef _TEX_DATA_
#define _TEX_DATA_

#include "include.h"

//----------------------------------------------------------
// eNX`C[WNX
//----------------------------------------------------------
struct TexImage
{
public:
	char *		pszFileName;	///< t@C(TGÂݑΉ)
	u16			usHeight;		///< 
	u16			usWidth;		///< 
	u32			unFormat;		///< tH[}bg
public:
	void Set( const char * fname ) {
		pszFileName = (char *)fname;

		// t@CTCYZbgTGAz肵Ă܂
		FILE * fp = fopen( fname, "rb" );
		assert(fp);

		fseek( fp, 0x0c, SEEK_SET );
		fread( &usWidth,  sizeof(u16), 1, fp );
		fread( &usHeight, sizeof(u16), 1, fp );
		fclose(fp);
		unFormat = GL_RGBA;
	}
};

//----------------------------------------------------------
// eNX`f[^NX
//----------------------------------------------------------
struct TexHeader
{
public:
	u32          unMipMapLevel;	///< ~bv}bvx
	TexImage *   pImage;		///< eNX`C[W
	int		     nWrapS;		///< Sbv
	int		     nWrapT;		///< Tbv
	int			 nMinFilter;	///< MintB^
	int			 nMagFilter;	///< MagtB^

public:
	void Set( TexImage * p ) {
		unMipMapLevel = 0;
		pImage = p;
		nWrapS = GL_REPEAT;
		nWrapT = GL_REPEAT;
		nMinFilter = GL_NEAREST;
		nMagFilter = GL_NEAREST;
	}
};

#endif //_TEX_DATA_
